; ------------------------------------------------------------------------
; MicryptionSuite - MircryptionBoard - v1.09.07 - messageboard/news bot, client helper script
;  intended for use with mircryotion addon.
; 5/29/04, Dark Raichu
;-------------------------------------------------------------------------
; See the mcboard help file for complete installation and usage info,
;  as well as a complete release history.
; ------------------------------------------------------------------------


; ------------------------------------------------------------------------
; INSTALLER, CALLED ONCE ON FIRST INSTALLATION
; just checks for the proper version of mirc
on 1:LOAD: {
  if ( $version < 5.9 ) {
    echo 7 -s $nopath($script) cannot be installed - it requires mIRC version 5.9 or later!
    echo
    mcboard_uninstall silent
    halt
  }
  echo 7 -si2 MircryptionSuite - MircryptionBoard script is now installed.  Use right-click pop-ups to access mcboard menus.
  echo 7 -si2 You can uninstall this script from the main menubar: Commands->mcboard->Uninstall.
}

; about function tells version
alias mcb_about {
  ; script version
  %mcb_scriptversion = 1.09.07
  if ($dialog(mcupdater_down).hwnd != $null) did -a mcupdater_down 7 MircryptionBoard ver %mcb_scriptversion loaded and ready. $+ $crlf
  else echo 7 -s MircryptionSuite - MircryptionBoard ver %mcb_scriptversion loaded and ready.
}
; ------------------------------------------------------------------------



; ------------------------------------------------------------------------
; INITIALIZATION STARTUP EACH TIME YOU LAUNCH MIRC
on 1:START: {
  ; Initialize mcboard for use

  ; let user know the script is loaded  
  .mcb_about

  ; set variables to defaults if they are not already set
  .setmcboardvariables

  ; start the optional autocheck timer
  .mcboard_setautochecktimer
}

; simple shortcut function that other scripts can use to check if mcboard is running.
; to check you would use this in your script:  if ($gotmcboard) ...
alias gotmcboard { return $true }

; signal used to tell all mircryption modules to show their version information
on *:SIGNAL:MircryptionInternalSignal_About: {
  .mcb_about
}
; ------------------------------------------------------------------------





; ------------------------------------------------------------------------
; HELP / ABOUT
alias mcboard {
  ; launch the help file if it is in mirc directory
  if ( $exists(mcboard.chm) ) .run mcboard.chm
  else if ( $exists(mcboard.hlp) ) .run mcboard.hlp
  ; now show commandline help in status window
  echo 7 -si4 - 
  echo 7 -si4 . MircryptionSuite - MircryptionBoard ver %mcb_scriptversion - Dark Raichu - 9/18/02
  echo 7 -si4 . 
  echo 7 -si2 . messageboard / news system for use with the mircryption cryptographic addon.
  echo 7 -si4 . 
  echo 7 -si2 . Use right-click popups to access mcboard menus.
  echo 7 -si4 . 
  echo 7 -si4 . NOTE: For detailed info see help file (Help->Help Files->MircryptionSuite).
  echo 7 -si2 . Uninstall script from the menu: Commands->mcboard->Uninstall.
  echo 7 -si2 - 
}
; ------------------------------------------------------------------------



; ---------------------------------------------------------------------------
; MENUS

menu menubar,status {
  &MCBoard
  .-
  .Uninstall the MCBoard script now:.mcboard_uninstall
  .-
  .help/about:.mcboard
}

menu channel {
  &MCBoard
  .List all board sections:.mcb_command list
  .List all board sections (compact):.mcb_command sections
  .Show all new items since last check:.mcb_command new
  .-
  .Show items from one section:.mcb_menucommand_showsection
  .Show all board items:.mcb_command show
  .-
  .Add item to board:.mcb_menucommand_additem
  .Add section to board:.mcb_menucommand_addsection
  .-
  .Add points to a score:.mcb_menucommand_addscore
  .Update activity:.mcb_menucommand_updateactivity
  .Update activity for all boards:.mcb_menucommand_updateactivityall
  ;.Add a calendar event:mcb_menucommand_addevent
  ..-
  .More Show Commands..
  ..List all board sections:.mcb_command list
  ..List all board sections (compact):.mcb_command sections
  ..Show all new items since last check:.mcb_command new
  ..-
  ..Show items from one section:.mcb_menucommand_showsection
  ..Show all board items:.mcb_command show
  ..-
  ..Show items from one section added in last x days:.mcb_menucommand_showsectiondays
  ..Show the last x items added to one section:.mcb_menucommand_showsectioncount
  ..-
  ..Show all items added in last x days:.mcb_menucommand_showdays
  ..Show the last x items added in each section:.mcb_menucommand_showcount
  ..Silently show all new news (no response if there is nothing new):.mcb_command silentnew
  .More Item Commands..
  ..Add item to board:.mcb_menucommand_additem
  ..Add privately encrypted item to board:.mcb_menucommand_addeitem
  ..Delete item from board:.mcb_menucommand_delitem
  ..Move item:.mcb_menucommand_movitem
  ..Replace item:.mcb_menucommand_repitem
  .More Section Commands..
  ..Add section to board:.mcb_menucommand_addsection
  ..Delete section from board:.mcb_menucommand_delsection
  ..Delete section from board by index number:.mcb_menucommand_delsectionnum
  ..Move section:.mcb_menucommand_movsection
  ..Change section name/label:.mcb_menucommand_repsection
  ..Clear section:.mcb_menucommand_clearsection
  .More Trimming Commands..
  ..Trim items from a section by date:.mcb_menucommand_trimsectiondays
  ..Trim items from a section by count:.mcb_menucommand_trimsectioncount
  ..Trim all items by date:.mcb_menucommand_trimdays
  ..Trim all items by count:.mcb_menucommand_trimcount
  .More Variable Commands..
  ..Get board variable:.mcb_menucommand_getboardvar
  ..Set board variable:.mcb_menucommand_setboardvar
  ..Set encrypted board variable:.mcb_menucommand_seteboardvar
  ..Add board variable:.mcb_menucommand_addboardvar
  ..Del board variable:.mcb_menucommand_delboardvar
  ..-
  ..Get section variable:.mcb_menucommand_getsectionvar
  ..Set section variable:.mcb_menucommand_setsectionvar
  ..Set encrypted section variable:.mcb_menucommand_setesectionvar
  ..Add section variable:.mcb_menucommand_addsectionvar
  ..Del section variable:.mcb_menucommand_delsectionvar
  ..-
  ;..List all variables:.mcb_command listvars
  .More Miscelaneous Comands..
  ..Add points to a score:.mcb_menucommand_addscore
  ..-
  ..Update activity:.mcb_menucommand_updateactivity
  ..Update activity with wa_link song info:.mcboard_walinkactivity
  ..-
  ..Update activity for all boards:.mcb_menucommand_updateactivityall
  ..Update activity for all boards with wa_link song info:.mcboard_walinkactivity all
  ;..-
  ;..Add a calendar event:mcb_menucommand_addevent
  ;..Configure newsboard autochecking:mcboard_configureautocheck
}


menu nicklist {
  .
  MCBoard - Configure [ $$1 ] as the MCBoard bot for [ $chan ]:/mcboard_configurebot [ $$1 ] [ $chan ]
}
;---------------------------------------------------------------------------






; ---------------------------------------------------------------------------
; ---------------------------------------------------------------------------
; intercept outgoing text to news bot and process it
on *:input:*: {

  if ($len($1-) > 650) {
    var %shorten = $len($1-) - 650
    echo 4 Mirc cannot handle safley lines bigger than about 850 characters, and encrypting lines expands them, so your text was NOT sent; please shorten it (by about %shorten $+ characters).
    haltdef
    halt
    return
  }

  ; mircryption messageboard
  if ( $1 == !mcb ) {
    .mcb_command $2-
    haltdef
  }
  if ( $1 == !mcball ) {
    .mcb_allcommand $2-
    haltdef
  }
}
; ---------------------------------------------------------------------------
; ---------------------------------------------------------------------------






; ---------------------------------------------------------------------------
; ---------------------------------------------------------------------------

alias mcb_command {
  ; just send the specified command to current channel
  .mcb_command_chan $chan $1-
}

alias mcb_allcommand {
  ; send the specified command to all channels
  .mcboard_sendallonlinebots $1-
}

alias mcb_command_chan {
  var %cname = $1

  ; process a command line to the mcboard bot of the current channel
  ; we are called with the command line to send to new bot.
  ; we need to figure out which is the bot nick for the current channel,
  ; then encrypt the PROPER SUBSECTIONS of the command line,
  ; then send it directly to the bot's nick

  ;/echo executing mcb_command %cname $2-

  ; name of nick who is bot
  var %botnick | %botnick = $mcboard_getbotnick(%cname)
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel %cname yet.  Right-click on the mcboard bot here to configure it.
    return
  }

  ; name of encryption key for this bot/channel
  var %botkeyname = [ mcboard_ $+ [ %cname ] $+ _ekey ]

  var %comword | %comword = $2
  var %sendtext | %sendtext = $null
  var %arg1
  var %arg2
  var %arg3

  ; show the person what command is being send
  ; /echo %cname [ $+ [ $nick ] $+ ] !mcb $2-
  ;  /echo %cname %botnick -> !mcb $2-

  ; aliases
  if (%comword == read) %comword = show

  if (%comword == $null) {
    %sendtext = new
  }
  else if (%comword == about) {
    %sendtext = $2-
  }
  else if (%comword == help) {
    %sendtext = $2-
  }
  else if (%comword == silentnew) {
    if ($3 == $null) %sendtext = $2
    else if ($3 != $null) %sendtext = Error: silentnew
  }
  else if ((%comword == show) || (%comword == showsection || (%comword == new) || (%comword == news) || (%comword == pubshow))) {
    if ($3 == $null) %sendtext = %comword
    else if ($4 != $null) %sendtext = Error: show || show SECTION
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = %comword %arg1
    }
  }
  else if (%comword == sections) {
    if ($3 != $null) %sendtext = Error: sections
    else {
      %sendtext = sections
    }
  }
  else if (%comword == showdays) {
    if (($3 == $null) || ($5 != $null)) %sendtext = Error: showdays [SECTION] DAYCOUNT
    if ($4 == $null) %sendtext = $2 $3
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1 $4-
    }
  }
  else if (%comword == showcount) {
    if (($3 == $null) || ($5 != $null)) %sendtext = Error: showcount [SECTION] ITEMCOUNT
    if ($4 == $null) %sendtext = $2 $3
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1 $4-
    }
  }
  else if (%comword == all) {
    if ($3 != $null) %sendtext = Error: show all
    else {
      %sendtext = show all
    }
  }
  else if ((%comword == list) || (%comword == listsection)) {
    if ($3 == $null) %sendtext = $2
    else if ($4 != $null) %sendtext = Error: list || list SECTION
    else {
      %arg1 =$mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1
    }
  }
  else if (%comword == add) {
    if ($4 == $null) %sendtext = Error: add SECTION ITEMTEXT..
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %arg2 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $4-)
      %sendtext = $2 %arg1 %arg2
    }
  }
  else if (%comword == adde) {
    if ($3 == $null) %sendtext = Error: add SECTION ITEMTEXT..
    else {
      %arg1 = $3
      %arg2 = $mcencryptecb(%botkeyname,$4)
      %arg3 = $dll( %mc_scriptdll , mc_encrypt2 , %arg1 $5-)
      if ( ( %arg3 == $null ) || ( %arg3 == $5- ) ) {
        %sendtext = Error: could not find a stored mircryption key for %arg1.
      }
      else %sendtext = add %arg2 %arg3
    }
  }
  else if (%comword == del) {
    if (($4 == $null) || ($5 != $null)) %sendtext = Error: del SECTION ITEM#
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1 $4
    }
  }
  else if (%comword == mov) {
    if (($5 == $null) || ($6 != $null)) %sendtext = Error: mov SECTION ITEM# NEWSECTION
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %arg2 = $mcencryptecb(%botkeyname,$5)
      %sendtext = $2 %arg1 $4 %arg2
    }
  }
  else if (%comword == rep) {
    if ($5 == $null) %sendtext = Error: rep SECTION ITEM# NEWITEMTEXT..
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %arg2 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $5-)
      %sendtext = $2 %arg1 $4 %arg2
    }
  }
  else if (%comword == trimsectiondays) {
    if (($4 == $null) || ($5 != $null)) %sendtext = Error: trimsectiondays SECTION DAYCOUNT
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1 $4
    }
  }
  else if (%comword == trimsectioncount) {
    if (($4 == $null) || ($5 != $null)) %sendtext = Error: trimsectioncount SECTION ITEMCOUNT
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1 $4
    }
  }
  else if (%comword == trimdays) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: trimdays DAYCOUNT
    else {
      %sendtext = $2 $3
    }
  }
  else if (%comword == trimcount) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: trimcount ITEMCOUNT
    else {
      %sendtext = $2 $3
    }
  }
  else if (%comword == clearsection) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: clearsection SECTION
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1
    }
  }
  else if (%comword == addsection) {
    if ($3 == $null) %sendtext = Error: addsection SECTION [LABELTEXT..]
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %arg2 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $4-)
      %sendtext = $2 %arg1 %arg2
    }
  }
  else if (%comword == delsection) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: delsection SECTION
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1
    }
  }
  else if (%comword == delsectionnum) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: delsectionnum #
    else {
      %sendtext = $2 $3
    }
  }

  else if (%comword == movsection) {
    if (($4 == $null) || ($5 != $null)) %sendtext = Error: movsection SECTION ABOVESECTION
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %arg2 = $mcencryptecb(%botkeyname,$4)
      %sendtext = $2 %arg1 %arg2
    }
  }
  else if (%comword == repsection) {
    if ($4 == $null) %sendtext = Error: repsection SECTION NEWSECTION [LABELTEXT..]
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %arg2 = $mcencryptecb(%botkeyname,$4)
      %arg3 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $5-)
      %sendtext = $2 %arg1 %arg2 %arg3
    }
  }
  else if (%comword == setboardvar) {
    if ($4 == $null) %sendtext = Error: setboardvar VARNAME VARVALUE..
    else {
      ; %arg1 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $3)
      %sendtext = $2 %arg1 $3 $4-
    }
  }
  else if (%comword == seteboardvar) {
    if ($4 == $null) %sendtext = Error: seteboardvar VARNAME VARVALUE..
    else {
      %arg1 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $4-)
      %sendtext = setboardvar $3 %arg1
    }
  }
  else if (%comword == getboardvar) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: getboardvar VARNAME
    else {
      ; %arg1 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $3)
      %sendtext = $2 $3
    }
  }
  else if (%comword == addboardvar) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: addboardvar VARNAME
    else {
      ; %arg1 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $3)
      %sendtext = $2 $3
    }
  }
  else if (%comword == delboardvar) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: delboardvar VARNAME
    else {
      ; %arg1 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $3)
      %sendtext = $2 $3
    }
  }
  else if (%comword == setsectionvar) {
    if ($4 == $null) %sendtext = Error: setsectionvar SECTIONNAME VARNAME VARVALUE..
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1 $4 $5-
    }
  }
  else if (%comword == setesectionvar) {
    if ($5 == $null) %sendtext = Error: setesectionvar SECTIONNAME VARNAME VARVALUE..
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %arg2 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname [ $5- ] )
      %sendtext = setsectionvar %arg1 $4 %arg2
    }
  }
  else if (%comword == getsectionvar) {
    if (($3 == $null) || ($5 != $null)) %sendtext = Error: getsectionvar SECTIONNAME  VARNAME
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1 $4
    }
  }
  else if (%comword == addsectionvar) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: addsectionvar SECTIONNAME  VARNAME
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1 $4
    }
  }
  else if (%comword == delsectionvar) {
    if (($3 == $null) || ($4 != $null)) %sendtext = Error: dellsectionvar SECTIONNAME  VARNAME
    else {
      %arg1 = $mcencryptecb(%botkeyname,$3)
      %sendtext = $2 %arg1 $4
    }
  }
  else if (%comword == listvars) {
    if ($3 != $null) %sendtext = Error: listvars
    else {
      %sendtext = listvars
    }
  }
  else if (%comword == addpoints) {
    if ($5 == $null) %sendtext = Error: addpoints SECTION ENTITYNAME POINTSTOADD [DESCRIPTION..]
    else {
      %arg1 = $mcencryptecb(%botkeyname,SCORES)
      %arg2 = $mcencryptecb(%botkeyname,$3)
      %arg3 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $5- )
      %sendtext = $2 %arg1 %arg2 $4 %arg3
    }
  }
  else if (%comword == activity ) {
    if ($2 == $null) %sendtext = Error: activity ACTIVITYDESCRIPTION..
    else {
      ; get the persons nick
      if (%mcb_activitynick == $null) {
        %mcb_activitynick = $input(Nickname to use for your activity entry (this is stored in alt-r variable "mcb_activitynick" for future use):,1,MCBoard News Bot)
        if (%mcb_activitynick == $null) return
      }
      %arg1 = $mcencryptecb(%botkeyname,ACTIVITIES)
      %arg2 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname %mcb_activitynick )
      if ( ($3 == $null) || ($3 == $chr(59)) ) %arg3 = $3
      else %arg3 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $3- )
      %sendtext = $2 %arg1 %arg2 %arg3
    }
  }
  else if (%comword == addevent) {
    if ($5 == $null) %sendtext = Error: addevent SECTION EVENTDATE DESCRIPTION..
    else {
      %arg1 = $mcencryptecb(%botkeyname,CALENDER )
      %arg2 = $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $5- )
      %sendtext = $2 %arg1 $4 %arg2
    }
  }
  else if (%comword == wl) {
    .mcboard_walinkactivity %cname
    return
  }

  ; show the person what command is being send
  ; /echo %cname [ $+ [ $nick ] $+ ] !mcb $2-
  /echo %cname %botnick -> !mcb $2-

  ; was there an error
  if ( $pos( %sendtext , Error , 1 ) > 0 ) {
    /echo 4 %sendtext 
  }
  else if (%sendtext == $null) {
    /echo 4 mcboard command not understood.
  }
  else {
    ; send the command to the news bot on this channel
    .mcb_chancommand %cname %sendtext
  }
}

alias mcb_chancommand {
  ; send a pre-formed (encrypted command to a news bot on a given channel)
  var %cname = $1
  var %sendtext = $2-

  ; name of nick who is bot
  var %botnick | %botnick = $mcboard_getbotnick(%cname)
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel %cname yet.  Right-click on the mcboard bot here to configure it.
    return
  }

  ; name of encryption key for this bot/channel
  var %botkeyname = [ mcboard_ $+ [ %cname ] $+ _ekey ]

  ; add the users ident override so it dont matter what your ident is when you chek for new news
  var %boardident = [ % $+ [ mcb_ $+ [ %cname ] $+ _boardident ] ]
  if (%boardident != $null) %sendtext = -i $+ %boardident %sendtext

  ; add the news board file name
  var %boardfilename = [ % $+ [ mcb_ $+ [ %cname ] $+ _boardname ] ]
  if (%boardfilename != $null) %sendtext = -b $+ %boardfilename %sendtext

  ; we add the admin password if it is defined
  var %boardpassname = [ % $+ [ mcb_ $+ [ %cname ] $+ _boardpass ] ]
  if (%boardpassname != $null) %sendtext = -p $+ %boardpassname %sendtext

  ; add our encrypted nick
  var %enick =  $dll( %mc_scriptdll , mc_encrypt2 , %botkeyname $me )
  if (%enick != $null) %sendtext = -e $+ %enick %sendtext

  ; add the channel
  ; fix the reply channel to remove multiserve stuff
  %cname = $cleanmultiserve(%cname)
  if (%cname != $null) %sendtext = -c $+ %cname %sendtext

  var %slen = $len(%sendtext)
  if ( %slen > %mc_maxirclinelen ) {
    if (%mcb_linelengthwarning != disable) {
      var %toobig = %slen - %mc_maxirclinelen
      /echo 4 The processed version of your post was too long (by about %toobig characters), and so was NOT sent; please shorten it.
      return
    }
  }

  ; to avoid opening private query window if user is using the local mcboard irc addon
  if ($me == %botnick) {
    ; invoke local mcboardbot
    .mcboardbot_command %sendtext
    } else {
    ; send command to bot
    /msg %botnick !mcb %sendtext
  }

  ; debug info
  if ($window(@MircDebugWindowPlus).wid != $null) {
    /echo @MircDebugWindowPlus NEWSBOARD BOT: Sending to %botnick ( %botkeyname ) !mcb %sendtext
  }
}

; ---------------------------------------------------------------------------
; ---------------------------------------------------------------------------




; ---------------------------------------------------------------------------
; MENU - GUI BASED SHORTCUTS
; these just collect some info from user and form the normal manual call to mcb_command
; ---------------------------------------------------------------------------
alias mcb_menucommand_showsection {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick($chan)
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to show:,1,MCBoard News Bot)
  if (%sectionname != $null) mcb_command show %sectionname
}

alias mcb_menucommand_additem {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick = $mcboard_getbotnick($chan)
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to add the item to:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the item text
  var %itemtext = $input(Item Text:,1,MCBoard News Bot)
  if (%itemtext == $null) return
  .mcb_command add %sectionname %itemtext
}

alias mcb_menucommand_addeitem {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick = $mcboard_getbotnick($chan)
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the name of the encryption key to use
  var %ekey = $input(Name of the stored mircryption key (nick or #channel) to encrypt item text to.  Your item will only be readable by people who also have this key.,1,MCBoard News Bot)
  if (%ekey == $null) return
  var %prevkey = $dll( %mc_scriptdll , mc_displaykey , %ekey)
  if (%prevkey == $null) {
    /echo 4 Error: could not find a stored key for %ekey $+ .
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the (private?) section to add the item to:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the item text
  var %itemtext = $input(Item Text:,1,MCBoard News Bot)
  if (%itemtext == $null) return
  .mcb_command adde %ekey %sectionname %itemtext
}

alias mcb_menucommand_delitem {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to delete an item from:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the item num
  var %itemnum = $input(Item # to delete:,1,MCBoard News Bot)
  if (%itemnum == $null) return
  .mcb_command del %sectionname %itemnum
}

alias mcb_menucommand_movitem {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to delete an item from:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the item num
  var %itemnum = $input(Item # to delete:,1,MCBoard News Bot)
  if (%itemnum == $null) return
  ; get new section
  var %newsectionname = $input(Name of the new section to move the item under:,1,MCBoard News Bot)
  if (%newsectionname == $null) return
  .mcb_command mov %sectionname %itemnum %newsectionname
}

alias mcb_menucommand_repitem {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section where the item resides:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the item num
  var %itemnum = $input(Item # to replace:,1,MCBoard News Bot)
  if (%itemnum == $null) return
  ; get the item text
  var %itemtext = $input(Replacement text for the item:,1,MCBoard News Bot)
  if (%itemtext == $null) return
  .mcb_command rep %sectionname %itemnum %itemtext
}


alias mcb_menucommand_addscore {
  ; fun command to keep score of something 
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }

  ; get the persons name
  var %itemname = $input(Name to add points to:,1,MCBoard News Bot)
  if (%itemname == $null) return

  ; get the score to add
  var %addpoints = $input(Points to add (use negative value to subtract points):,1,MCBoard News Bot)
  if (%addpoints == $null) return

  ; get the reason
  var %reason = $input(Reason for points:,1,MCBoard News Bot)
  if (%reason == $null) return
  .mcb_command addpoints %itemname %addpoints %reason
}


alias mcb_menucommand_updateactivity {
  ; fun command to keep list of what people are up to 
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }

  ; get the activity description to add
  var %activitystr = $input(Now type in a description of what you are currently doing:,1,Current activity)
  if (%activitystr == $null) return

  .mcb_command activity %activitystr
}

alias mcb_menucommand_updateactivityall {
  ; fun command to keep list of what people are up to 
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }

  ; get the activity description to add
  var %activitystr = $input(Now type in a description of what you are currently doing (to be broadcast to ALL board bots on ALL channels):,1,Current activity to send to ALL bots)
  if (%activitystr == $null) return
  .mcboard_sendallonlinebots activity %activitystr
}

alias mcb_menucommand_addevent {
  ; add an event with a date
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }

  ; get the event date
  var %eventdate = $input(Event Date:,1,MCBoard News Bot)
  if (%eventdate == $null) return
  ; get the event text
  var %eventtext = $input(Event Description:,1,MCBoard News Bot)
  if (%eventtext == $null) return
  .mcb_command addevent %eventdate %eventtext 
}



alias mcb_menucommand_trimdays {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the trim days
  var %trimdays = $input(Clear all items older than how many days:,1,MCBoard News Bot)
  if (%trimdays == $null) return
  .mcb_command trimdays %trimdays
}

alias mcb_menucommand_trimcount {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  ; get the trim count
  var %trimcount = $input(Keep how many of the newest items:,1,MCBoard News Bot)
  if (%trimcount == $null) return
  .mcb_command trimcount  %trimcount
}

alias mcb_menucommand_trimsectiondays {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to trim:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the trim days
  var %trimdays = $input(Clear all items in section older than how many days:,1,MCBoard News Bot)
  if (%trimdays == $null) return
  .mcb_command trimsectiondays %sectionname %trimdays
}

alias mcb_menucommand_trimsectioncount {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to trim:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the trim count
  var %trimcount = $input(Keep how many of the newest items from the section:,1,MCBoard News Bot)
  if (%trimcount == $null) return
  .mcb_command trimsectioncount %sectionname %trimcount
}

alias mcb_menucommand_clearsection {  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick($chan)
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to clear all items from:,1,MCBoard News Bot)
  if (%sectionname != $null) .mcb_command clearsection %sectionname
}

alias mcb_menucommand_addsection {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to add:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  var %sectionlabel = $input(Label for the section (can be longer description):,1,MCBoard News Bot)
  .mcb_command addsection %sectionname %sectionlabel
}

alias mcb_menucommand_delsection {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to delete:,1,MCBoard News Bot)
  if (%sectionname != $null) .mcb_command delsection %sectionname
}

alias mcb_menucommand_delsectionnum {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionnum = $input(Section Number (with 1 being first section) of the section to delete:,1,MCBoard News Bot)
  if (%sectionnum != $null) .mcb_command delsectionnum %sectionnum
}

alias mcb_menucommand_movsection {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to move:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get new section
  var %newsectionname = $input(Move this section above which existing section:,1,MCBoard News Bot)
  if (%newsectionname == $null) return
  .mcb_command movsection %sectionname %newsectionname
}

alias mcb_menucommand_repsection {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to rename:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get new section
  var %newsectionname = $input(Rename this section to (specify a short name with no spaces):,1,MCBoard News Bot)
  if (%newsectionname == $null) return
  var %newsectionlabel = $input(New label for the section (can be longer description):,1,MCBoard News Bot)
  if (%newsectionlabel == $null) return
  .mcb_command repsection %sectionname %newsectionname %newsectionlabel
}

alias mcb_menucommand_setboardvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the var name
  var %varname = $input(Name of the board variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  ; new value
  var %varval = $input(New value for the variable:,1,MCBoard News Bot)
  if (%varval == $null) return
  .mcb_command setboardvar %varname %varval
}

alias mcb_menucommand_seteboardvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the var name
  var %varname = $input(Name of the board variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  ; new value
  var %varval = $input(New value for the variable (will be encrypted before being sent):,1,MCBoard News Bot)
  if (%varval == $null) return
  .mcb_command seteboardvar %varname %varval
}

alias mcb_menucommand_getboardvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the var name
  var %varname = $input(Name of the board variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  .mcb_command getboardvar %varname
}

alias mcb_menucommand_addboardvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the var name
  var %varname = $input(Name of the board variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  .mcb_command addboardvar %varname
}
alias mcb_menucommand_delboardvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the var name
  var %varname = $input(Name of the board variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  .mcb_command delboardvar %varname
}

alias mcb_menucommand_setsectionvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the variable's section:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the var name
  var %varname = $input(Name of the section variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  ; new value
  var %varval = $input(New value for the variable:,1,MCBoard News Bot)
  if (%varval == $null) return
  .mcb_command setsectionvar %sectionname %varname %varval
}
alias mcb_menucommand_setesectionvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the variable's section:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the var name
  var %varname = $input(Name of the section variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  ; new value
  var %varval = $input(New value for the variable (will be encrypted before sending):,1,MCBoard News Bot)
  if (%varval == $null) return
  .mcb_command setesectionvar %sectionname %varname %varval
}
alias mcb_menucommand_getsectionvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the variable's section:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the var name
  var %varname = $input(Name of the section variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  .mcb_command getsectionvar %sectionname %varname
}
alias mcb_menucommand_addsectionvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the variable's section:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the var name
  var %varname = $input(Name of the section variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  .mcb_command addsectionvar %sectionname %varname
}
alias mcb_menucommand_delsectionvar {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the variable's section:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the var name
  var %varname = $input(Name of the section variable:,1,MCBoard News Bot)
  if (%varname == $null) return
  .mcb_command delsectionvar %sectionname %varname
}

alias mcb_menucommand_showdays {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the show days
  var %showdays = $input(Show all items newer than how many days:,1,MCBoard News Bot)
  if (%showdays == $null) return
  .mcb_command showdays %showdays 
}

alias mcb_menucommand_showcount {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the show count
  var %showcount = $input(Show how many of the newest items from each section:,1,MCBoard News Bot)
  if (%showcount == $null) return
  .mcb_command showcount %showcount 
}

alias mcb_menucommand_showsectiondays {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to show:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the show days
  var %showdays = $input(Show all items newer than how many days:,1,MCBoard News Bot)
  if (%showdays == $null) return
  .mcb_command showdays %sectionname %showdays
}

alias mcb_menucommand_showsectioncount {
  ; first make sure there is a news bot configured for this channel and warn if not
  var %botnick | %botnick = $mcboard_getbotnick( $chan )
  if (%botnick == $null) {
    echo 4 No mcboard bot has been selected for channel $chan yet.  Right-click on the mcboard bot here to configure it.
    return
  }
  ; get the section name
  var %sectionname = $input(Name of the section to show:,1,MCBoard News Bot)
  if (%sectionname == $null) return
  ; get the show count
  var %showcount = $input(Show how many of the newest items from each section:,1,MCBoard News Bot)
  if (%showcount == $null) return
  .mcb_command showcount %sectionname %showcount
}

; ---------------------------------------------------------------------------
; ---------------------------------------------------------------------------



; ---------------------------------------------------------------------------
; ---------------------------------------------------------------------------

alias mcboard_configurebot {
  ; we are called with $nick and $chan and we want to record in a variable that the news bot for channel $chan is $nick
  ; this is necesary so that when our user issues a news command, we know who to send it to.  This nick will also
  ; be used to store the mircryption key for encrypted news boards.
  var %nname | %nname = $1
  var %cname | %cname = $2
  var %botkey = $null
  var %botkeyname = $null
  var %boardpass = $null=
  var %boardpassname = $null
  var %boardfile = $null
  var %boardfilename = $null
  var %boardident = $null
  var %retv
  var %prevkey

  ; the stored mircryption key for the nick (ie board contents)
  %botkeyname = [ mcboard_ $+ [ $chan ] $+ _ekey ]
  %prevkey = $dll( %mc_scriptdll , mc_displaykey , %botkeyname)
  if (%prevkey != $null) %botkey = $input(MCBoard News Bot Encryption Keyphrase.  This should be a long (25-35 character) sentence which cannot be guessed:,1,Change mircryption keyphrase for newsbot,%prevkey)
  else %botkey = $input(MCBoard News Bot Encryption Keyphrase.  This should be a long (25-35 character) sentence which cannot be guessed:,1,Set mircryption keyphrase for newsbot)

  ; the name of the news file - optional overide of the default news file, useful for multiple news boards run by same bot
  %prevkey = [ % $+ [ mcb_ $+ [ %cname ] $+ _boardname ] ]
  if (%prevkey != $null) %boardfile = $input(Name of the specific news board associated with this channel (ask newsboard server admin),1,News Board Name,%prevkey)
  else %boardfile = $input(Name of the specific news board associated with this channel (ask newsboard server admin),1,News Board Name)

  ; optional board admin pass -  used for priveledged admin board operations
  %prevkey = [ % $+ [ mcb_ $+ [ %cname ] $+ _boardpass ] ]
  if (%prevkey != $null) %boardpass = $input(Set the (optional) administration password of this board? Most people leave this blank. This is sent in clear text - do NOT use sensitive text!,1,Optional MCBoard News Bot Admin Password,%prevkey)
  else %boardpass = $input(Set the (optional) administration password of this board? Most people leave this blank. This is sent in clear text - do NOT use sensitive text!,1,Optional MCBoard Admin Password)

  ; optional identname -  used to keep track of when you last checked your mail
  %prevkey = [ % $+ [ mcb_ $+ [ %cname ] $+ _boardident ] ]
  if (%prevkey != $null) %boardident = $input(Unique ident keyword for tracking unread messages.  Use a single non-sensitive word.  Use the same keyword on all copies of mirc:,1,MCBoard Ident Keyword,%prevkey)
  else %boardident = $input(Unique ident keyword for tracking unread messages.  Use a single non-sensitive word.  Use the same keyword on all copies of mirc:,1,MCBoard Ident Keyword)
  if ((%boardident == $null) && (%prevkey != $null)) {
    %boardident = %prevkey
  }

  ; set bot keyphrase in mircryption keys
  if (%botkey != $null) {
    %retv = $dll( %mc_scriptdll , mc_setkey , %botkeyname %botkey)
    if ((%retv != $null) && (%retv != %botkeyname)) echo 4 -s %retv
  }

  ; set ecb version of key using name $+ _ecb
  ; we need this for encryption section names
  if (%botkey != $null) {
    var %ecbkey = %botkey
    if ( $left(%ecbkey ,4) == cbc; ) {
      %ecbkey = $mid(%ecbkey ,5);
    }
    if ( $left(%ecbkey ,4) == cbc: ) {
      %ecbkey = $mid(%ecbkey ,5);
    }
    var %ecbbotkeyname = %botkeyname $+ _ecb
    %retv = $dll( %mc_scriptdll , mc_setkey , %ecbbotkeyname %ecbkey )
    if ((%retv != $null) && (%retv != %ecbbotkeyname )) echo 4 -s %retv
  }


  ; set board bot nick var
  if (%cname != $null) set [ % $+ [ mcb_ $+ [ %cname ] $+ _botnick ] ] %nname

  ; set board name var
  if (%boardfile != $null) set [ % $+ [ mcb_ $+ [ %cname ] $+ _boardname ] ] %boardfile 

  ; set admin pass var
  set [ % $+ [ mcb_ $+ [ %cname ] $+ _boardpass ] ] %boardpass

  ; set ident
  set [ % $+ [ mcb_ $+ [ %cname ] $+ _boardident ] ] %boardident
}

alias mcboard_getbotnick {
  ; return the nick of the bot on the passed channel

  var %cname | %cname = $1
  var %botnick

  if (%cname == $null) %cname = $chan
  if (%cname == $null) %cname = $active
  if (%cname == $null) return ""

  %botnick = [ % $+ [ mcb_ $+ [ %cname ] $+ _botnick ] ]
  ; echo botnick is %botnick
  return %botnick
}

alias mcboard_configureautocheck {
  ; configure autochecking options
  var %preval
  var %checkinterval
  %preval = %mcb_autocheckinterval
  if (%preval != $null) %checkinterval = $input(How many seconds to wait between automatic checks for new news on all channels (use 0 to disable):,1,Autocheck News Boards,%preval)
  else %checkinterval = $input(How many seconds to wait between automatic checks for new news on all channels (use 0 to disable):,1,Autocheck News Boards)
  if (%checkinterval == $null) return
  if ( (%checkinterval > 0) && (%checkinterval < 10) ) %checkinterval = 10
  %mcb_autocheckinterval = %checkinterval
  .mcboard_setautochecktimer
}
; ---------------------------------------------------------------------------
; ---------------------------------------------------------------------------





; ---------------------------------------------------------------------------
alias mcboard_setautochecktimer {
  ; update the autocheck timer
  if ( %mcb_autocheckinterval == $null) return
  if ( %mcb_autocheckinterval <= 0) .timermcbautocheck off
  else .timermcbautocheck 0 [ %mcb_autocheckinterval ] /mcboard_autocheck
}

alias mcboard_autocheck {
  ; first check if we are connected to a server, if not skip the check
  if (($server == $null) && ($status != connected)) return

  ; now check the boards for each channel we are joined to
  ; BUT we want to be smart and not check the same board multiple times if it is set identically for dif channels
  var %boardschecked = $null
  var %cname
  var %botnick
  var %botkeyname
  var %boardfilename
  var %uniquename
  var %sendtext
  var %isbotonline

  ; loop through channels
  var %ccount = 1
  while ($chan(%ccount) != $null) {
    %cname = $chan(%ccount)
    %botnick = $mcboard_getbotnick(%cname)
    %botkeyname = [ mcboard_ $+ [ %cname ] $+ _ekey ]
    %boardfilename = [ % $+ [ mcb_ $+ [ %cname ] $+ _boardname ] ]
    if ((%botnick != $null) && (%botkeyname != $null) && (%boardfilename != null)) {
      ; ok we have a valid news board for this channel, now see if we've checked it yet this round
      %uniquename = %botnick $+ _ $+ %boardfilename
      %isbotonline = $comchan(%botnick , 0)
      if ($istok(%boardschecked , %uniquename , 44)) %uniquename = $null
      else if (%isbotonline > 0) {
        ; has not been checked yet, and the news bot is online so we check it
        %sendtext = silentnew
        .mcb_chancommand %cname %sendtext
        ; and add it to the list of checked boards
        %boardschecked = [ %boardschecked ] $+ , $+ [ %uniquename ]
      }
    }
    inc %ccount
  }
  ; /echo -s DEBUG checked %boardschecked
}
; ---------------------------------------------------------------------------



; ---------------------------------------------------------------------------
alias mcboard_sendallonlinebots {
  ; generic routine to send all news bots on all channels (where the bots are online) the same message

  ; first check if we are connected to a server, if not skip the check
  if (($server == $null) && ($status != connected)) return $true

  ; now check the boards for each channel we are joined to
  ; BUT we want to be smart and not check the same board multiple times if it is set identically for dif channels
  var %boardschecked = $null
  var %cname
  var %botnick
  var %botkeyname
  var %boardfilename
  var %uniquename
  var %sendtext
  var %isbotonline

  ; loop through channels
  var %ccount = 1
  while ($chan(%ccount) != $null) {
    %cname = $chan(%ccount)
    %botnick = $mcboard_getbotnick(%cname)
    %botkeyname = [ mcboard_ $+ [ %cname ] $+ _ekey ]
    %boardfilename = [ % $+ [ mcb_ $+ [ %cname ] $+ _boardname ] ]
    if ((%botnick != $null) && (%botkeyname != $null) && (%boardfilename != null)) {
      ; ok we have a valid news board for this channel, now see if we've checked it yet this round
      %uniquename = %botnick $+ _ $+ %boardfilename
      %isbotonline = $comchan(%botnick , 0)
      if ($istok(%boardschecked , %uniquename , 44)) %uniquename = $null
      else if (%isbotonline > 0) {
        ; has not been checked yet, and the news bot is online so we send it
        %sendtext = $1-
        .mcb_command_chan %cname %sendtext
        ; and add it to the list of checked boards
        %boardschecked = [ %boardschecked ] $+ , $+ [ %uniquename ]
      }
    }
    inc %ccount
  }
  ; /echo -s DEBUG mcboard_sendallonlinebots boards checked= %boardschecked
}
; ---------------------------------------------------------------------------





;--------------------------------------------------------------------------- 
;STARTUP AND HELPER FUNCTIONS

alias setmcboardvariables {
  ; default persistant variables - if they are blank they will be set here. after that you can set
  ;  them programmaticaly in a script OR in the alt-R variables section, and they will preserver
  ;  even if you install a new version.
  if (%mc_maxirclinelen == $null) %mc_maxirclinelen = 450
  if (%mcb_linelengthwarning == $null) %mcb_linelengthwarning = enable
  if (%mcb_dedicated_notice_window == $null) %mcb_dedicated_notice_window = $null
}


; uninstall helper
alias mcboard_uninstall {
  ; uninstall script
  ; erase all permanent variables related to script

  if ( $1 != silent ) {
    ; verify they really want to install it
    var %confirmer
    %confirmer = $input(Type the word 'uninstall' to confirm uninstallation:,1,Uninstall MCBoard)
    if (%confirmer != uninstall) {
      echo 7 -s Uninstallation of MCBoard canceled.
      return
    }
  }
  unset %mcb_*
  echo 7 -s MCBoard script $nopath($script) has been uninstalled.
  echo 7 -s To reinstall, type /load -rs mcboard.mrc
  .unload -rs mcboard.mrc
  .unload -rs mircryption\mcboard.mrc
  .unload -rs $script
  halt
}

;--------------------------------------------------------------------------- 







;--------------------------------------------------------------------------- 
; OTHER HELPERS

alias mcboard_currentchannelkey {
  ; lookup mircryption current channel key
  if ( $isfile("mircryption.dll") ) {
    return $dll( %mc_scriptdll , mc_displaykey , $1)
  }
  else {
    return $null
  }
}

alias mcboard_identnick {
  ; find ident associated with nick
  ; this just does not work reliably, espcially with bncs, even if we force /who, etc.
  ; for now, we are justgoing to return the nick as the ident
  var %retv
  %retv = $address( $1 , 1 )
  return %retv
}

alias mcboard_testident {
  ; find ident associated with nick
  var %retv
  %retv = $address( $1 , 1 )
  echo Address %retv
  /userhost $1
  %retv = $chan $+ : $+ $1
  echo -s ANSER: %retv
  return
}
;--------------------------------------------------------------------------- 





;--------------------------------------------------------------------------- 
; EVENT HELPERS

on *:JOIN:#: {
  ; when autochecking is on, we also check for new news when we join (note we can set %mcb_autocheckinterval to -1 to employ ONLY checking on join)
  if (%mcb_autocheckinterval == $null) return
  if (%mcb_autocheckinterval == 0) return

  var %cname
  var %botnick
  var %botkeyname
  var %boardfilename
  var %isbotonline
  var %sendtext

  %cname = $chan
  %botnick = $mcboard_getbotnick(%cname)
  %botkeyname = [ mcboard_ $+ [ %cname ] $+ _ekey ]
  %boardfilename = [ % $+ [ mcb_ $+ [ %cname ] $+ _boardname ] ]
  if ((%botnick != $null) && (%botkeyname != $null) && (%boardfilename != null)) {
    %isbotonline = $comchan(%botnick , 0)
    if (%isbotonline > 0) {
      %sendtext = silentnew
      .mcb_chancommand %cname %sendtext
    }
  }
}
;--------------------------------------------------------------------------- 






;---------------------------------------------------------------------------
; fun helper for wa_link winamp controller

alias mcboard_walinkactivity {
  var %WA.Stats

  ;  set %WA.Stats $dll($shortfn($mircdirWA_Link\WA_Link.dll),WA_Link_Stats,%WA.Theme)

  ;  ;Replace all fakespaces with realspaces
  ;  set %WA.Stats $replace(%WA.Stats,$chr(160),$chr(32))

  ;  ;Replace all commans with fakespaces
  ;  set %WA.Stats $replace(%WA.Stats,$chr(44),$chr(160))

  ;  ;Eval theme
  ;  set %WA.Stats $eval(%WA.Stats,2)

  ;  ;Replace all fakespaces with commas
  ;  set %WA.Stats $replace(%WA.Stats,$chr(160),$chr(44))

  var %wa.info1 = $dll($shortfn($mircdirWA_Link\WA_Link.dll), WA_Link_Raw_Stats, TITLE) 
  if ( %wa.info1 == $null ) {
    /echo WA_link dll (for interacting with winamp) was not found.  See http://www.base.is/thecrew/ for more information.
    return
  }
  if ( %wa.info1 == $false ) {
    /echo WA_link dll reports that no song is currently playing, so nothing to send.
    return
  }

  var %wa.info2 = $dll($shortfn($mircdirWA_Link\WA_Link.dll), WA_Link_Raw_Stats, ARTIST)
  if (%wa.info2 != $null) { %wa.info2 = %wa.info2 - %wa.info1 }
  else { %wa_info2 = $wa_info1 }

  %WA.Stats = %wa.info2
  ; now update current board activity with what you are listening to
  var %activitystr = listening to: %WA.Stats
  if ($1 == $null) .mcb_command activity %activitystr
  elseif ($1 == all) .mcboard_sendallonlinebots activity %activitystr
  else .mcb_command_chan $1 activity %activitystr   
}

;---------------------------------------------------------------------------




;---------------------------------------------------------------------------
; optional menus for addons
;menu channel {
;  WA Link
;  .$submenu($mcboard_optionalmenu_walink($1))
;}

alias mcboard_optionalmenu_walink {
  if ( $exists(WA_Link) ) {
    if ($1 == 1) return ..Update MCBooard activity with song info:.mcboard_walinkactivity
    if ($1 == 2) return ..Update activity for all boards with wa_link song info:.mcboard_walinkactivity all
    if ($1 == 3) return
  }
}
; ---------------------------------------------------------------------------


;---------------------------------------------------------------------------
alias mcencryptecb {
  ; encrypt the uppercase version of $2 using key $1,
  ; BUT use an ecb key even if $1 is cbc (this is needed for section names that must not change)
  var %keyname = $1
  var %encryptstring = $2-
  var %retv
  %encryptstring = $upper(%encryptstring)

  ; fix key to ecb

  var %ecbkeyname = %keyname $+ _ecb
  var %keyvalue = $dll( %mc_scriptdll , mc_displaykey , %ecbkeyname )
  if (%keyvalue == $null) {
    ; hmm, ecb not set because of new upgrade, so now we set it
    var %ecbkey = $dll( %mc_scriptdll , mc_displaykey , %keyname )
    if ( $left(%ecbkey ,4) == cbc; ) {
      %ecbkey = $mid(%ecbkey ,5);
    }
    if ( $left(%ecbkey ,4) == cbc: ) {
      %ecbkey = $mid(%ecbkey ,5);
    }
    %retv = $dll( %mc_scriptdll , mc_setkey , %ecbkeyname %ecbkey )
    %keyvalue = %ecbkey
  }

  if (%keyvalue != $null) {
    ; ok ecb version exists, so use it instead of normal key
    %keyname = %ecbkeyname
  }

  ; encrypt
  %retv = $dll( %mc_scriptdll  , mc_encrypt2 , %keyname %encryptstring)
  return %retv
}
;---------------------------------------------------------------------------



;---------------------------------------------------------------------------
; command to use a bot ventriliquist which is encryptes
; call this by typing, in a channel with a bot configured and a pass configured for that channel:  /botspeak [TEXT YOU WANT BOT TO SAY]
; this function is only useful if you install the msg_say.tcl script in your eggdrop which lets you speak through your bot.
; it is just a shortcut function which encrypts the text before passing it through to default news bot
;alias botsay {
;  var %isbotonline
;  var %emesg
;  var %botnick = $mcboard_getbotnick($chan)
;  var %ekeyname = $chan
;  if ( (%botnick != $null) && (%ekeyname != $null) ) {
;    %isbotonline = $comchan(%botnick , 0)
;    if (%isbotonline > 0) {
;      ; encrypt method 1
;      ; %emesg = $dll( %mc_scriptdll  , mc_encrypt , %ekeyname $1-)
;      ; encrypt method 2
;      %emesg = $dll( %mc_scriptdll , mc_encrypt2 , %ekeyname $1-)
;      ; encrypt and send message
;      if (%emesg != $null) {
;        ; I ALTERED MY SCRIPT FROM SAY TO BOTSAY.  ORIGINAL WAS:  /msg %botnick !say $chan %emesg
;        .msg %botnick !botsay $chan %emesg
;        ; /msg %botnick !botsay $chan %emesg
;        return
;      }
;    }
;  }
;  echo 4 could not send message (not bot configured or bad password)
;}
;---------------------------------------------------------------------------






;---------------------------------------------------------------------------
; end of file
